<h3>Superviser</h3>
<div id="cleared"></div>

<div class="row">
    <div class="col-sm">
        <div class="info-box">
            <span class="info-box-icon bg-info elevation-1"><i class="fas fa-cog"></i></span>
            <div class="info-box-content">
                <span class="info-box-text">En fonctionnement</span>
                <span id="cnt_current_running" class="info-box-number"></span>
            </div>
        </div>
    </div>
    <div class="col-sm">
        <div class="info-box mb-3">
            <span class="info-box-icon bg-danger elevation-1"><i class="fas fa-thumbs-up"></i></span>
            <div class="info-box-content">
                <span class="info-box-text">Simultanées (max)</span>
                <span id="cnt_running_max" class="info-box-number"></span>
            </div>
        </div>
    </div>
    <div class="col-sm">
        <div class="info-box mb-3">
            <span class="info-box-icon bg-success elevation-1"><i class="fas fa-clipboard-list"></i></span>
            <div class="info-box-content">
                <span class="info-box-text">Depuis le début (total)</span>
                <span id="cnt_vm_from_the_beginning" class="info-box-number"></span>
            </div>
        </div>
    </div>
    <div class="clearfix hidden-md-up"></div>
</div>

<div class="row">
    <div class="col">
        <div class="card card-default">
            <div class="card-header">
                <div class="row">
                    <div class="btn-group btn-group-toggle" data-toggle="buttons">
                        <label class="btn btn-primary active">
                            <input type="radio" name="options" id="hour" autocomplete="off" checked><i class="fas fa-clock"></i> Heure
                        </label>
                        <label class="btn btn-primary">
                            <input type="radio" name="options" id="day" autocomplete="off"><i class="fas fa-calendar-day"></i> Jour
                        </label>
                      </div>
                </div>
            </div>

            <div class="card-body">
                <div class="row">
                    <div class="col-sm">
                        <div class="card">
                            <div class="card-header">
                                <h3>Démarrée(s)</h3>
                            </div>
                            <div class="card-body p-0">
                                <canvas id="started-chart"></canvas>
                            </div>
                        </div>
                    </div>

                    <div class="col-sm">
                        <div class="card">
                            <div class="card-header">
                                <h3>Mémoire utilisée (Go)</h3>
                            </div>
                            <div class="card-body p-0">
                                <canvas id="memory-chart"></canvas>
                            </div>
                        </div>
                    </div>
                </div>

                <div class="row">
                    <div class="col-sm">
                        <div class="card mt-3">
                            <div class="card-header">
                                <h3>Stockage utilisé (Go)</h3>
                            </div>
                            <div class="card-body p-0">
                                <canvas id="storage-chart"></canvas>
                            </div>
                        </div>
                    </div>

                    <div class="col-sm">
                        <div class="card mt-3">
                            <div class="card-header">
                                <h3>Utilisation CPU (%)</h3>
                            </div>
                            <div class="card-body p-0">
                                <canvas id="cpu_usage-chart"></canvas>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<div class="row mt-3">
    <div class="col-sm">
        <div class="card">
            <div class="card-header">
                <h3>Environnements</h3>
            </div>
            <div class="card-body p-0">
                <div class="table-responsive">
                <table class="table table-striped">
                <thead>
                    <tr>
                        <th>Environnement</th>
                        <th>Total</th>
                        <th>En cours</th>
                    </tr>
                </thead>
                <tbody id="Challenges_items">
                </tbody>
                </table>
                </div>
            </div>
        </div>
    </div>

    <div class="col-sm">
        <div class="card">
            <div class="card-header">
                <h3>Teams</h3>
            </div>
            <div class="card-body p-0">
                <div class="table-responsive">
                    <table class="table table-striped">
                        <thead>
                            <tr>
                                <th>Team</th>
                                <th>Total</th>
                                <th>En cours</th>
                            </tr>
                        </thead>
                        <tbody id="Challenges_teams">
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>
</div>

<script>
    var refreshStatsTimer;
    var startedChart;
    var memoryChart;
    var storageChart;
    var cpu_usageChart;
    var type_stats=0; // 0 -> 1 hour , 1 -> 1 day
    var items_count=60; // 60 minutes by default because display 1 hour
    var cacheChart={};
    // to force to get full datas from backend (if true)
    // 0 -> 1 hour , 1 -> 1 day
    var datasOutdated={ 0:true, 1: true };

    $(document).ready(function() {
        startedChart=getChartObject("started-chart", "Started", "#3e95cd");
        memoryChart=getChartObject("memory-chart", "Memory", "#3e95cd", float=true);
        storageChart=getChartObject("storage-chart", "Storage", "#3e95cd", float=true);
        cpu_usageChart=getChartObject("cpu_usage-chart", "CPU", "#3e95cd", float=true);
        refreshStatsTimer=setInterval(refreshStats, 60000);
        // First time
        getInitialChartDatas();
        refreshStats(); // for other datas
    });


    function getInitialChartDatas(type_date=0) {
        type_stats=type_date;
        datasOutdated[type_date]=false;
        if (type_date==0) {
            url='/api/stats?lasthour';
        }
        else if (type_date==1) {
            url='/api/stats?lastday';
        }
        else
            return
        $.ajax({
            url: url,
            dataType: 'json',
            }).done(function (response) {
            if (response.success == true) {
                // add to cache
                cacheChart[type_stats]={};
                var cachechart=cacheChart[type_date];
                setItemChart(cachechart, 'startedChart', response.labels_started, response.datas_started);
                setItemChart(cachechart, 'memoryChart', response.labels_memory, response.datas_memory, response.data_total_memory);
                setItemChart(cachechart, 'storageChart', response.labels_storage, response.datas_storage, response.data_total_storage);
                setItemChart(cachechart, 'cpu_usageChart', response.labels_cpu_usage, response.datas_cpu_usage, 100);
                drawChartsFromCache();
            }
        });
    };

    function trampolineForChartObj(chartObj, cacheObj) {
        changeFullContentOfChart(chartObj, cacheObj.labels, cacheObj.datas, cacheObj.max);
    }

    function drawChartsFromCache() {
        var cachechart=cacheChart[type_stats];
        trampolineForChartObj(startedChart, cachechart.startedChart);
        trampolineForChartObj(memoryChart, cachechart.memoryChart);
        trampolineForChartObj(storageChart, cachechart.storageChart);
        trampolineForChartObj(cpu_usageChart, cachechart.cpu_usageChart);
    }

    function refreshStats() {
        if (type_stats==0) { // 1 hour
            url='/api/stats?current&hour';
            datasOutdated[1]=true; // todo refresh days datas
        } else if (type_stats==1) { // 1day
            url='/api/stats?current&day';
            datasOutdated[0]=true; // todo refresh hours datas
        }
        else
            return
        $.ajax({
            url: url,
            dataType: 'json',
            }).done(function (response) {
            if (response.success == true) {
                $("#cnt_running_max").html(response.cnt_running_max);
                $("#cnt_current_running").html(response.cnt_current_running);
                $("#cnt_vm_from_the_beginning").html(response.cnt_vm_from_the_beginning);
                var content="";
                jQuery.each(response.per_vm, function(index, value){
                    content+=" \
                    <tr> \
                        <td><strong>"+value[0]+"</strong></td> \
                        <td>"+value[1]+"</td> \
                        <td>"+value[2]+"</td> \
                    </tr>";
                });
                $("#Challenges_items").html(content);
                var content="";
                jQuery.each(response.per_team, function(index, value){
                    content+=" \
                    <tr> \
                        <td><strong>"+value[0]+"</strong></td> \
                        <td>"+value[1]+"</td> \
                        <td>"+value[2]+"</td> \
                    </tr>";
                });
                $("#Challenges_teams").html(content);
                if (response.last_item_started!==null) {
                    label=response.last_item_started[0];
                    data=response.last_item_started[1];
                    addData(startedChart, label, data, items_count);
                }
                if (response.last_item_memory!==null) {
                    label=response.last_item_memory[0];
                    data=response.last_item_memory[1];
                    addData(memoryChart, label, data, items_count);
                }
                if (response.last_item_storage!==null) {
                    label=response.last_item_storage[0];
                    data=response.last_item_storage[1];
                    addData(storageChart, label, data, items_count);
                }
                if (response.last_item_cpu_usage!==null) {
                    label=response.last_item_cpu_usage[0];
                    data=response.last_item_cpu_usage[1];
                    addData(cpu_usageChart, label, data, items_count);
                }
            }
        });
    };

    function changeFullContentOfChart(chart, labels, datas, max=null) {
        chart.data.labels=labels;
        chart.data.datasets[0].data=datas;
        if (max!==null) {
            chart.options.scales.yAxes[0].ticks.max=max;
        }
        chart.update();
    }

    function addData(chart, label, data, max_items) {
        // already exist ?
        if (! chart.data.labels.includes(label)) {
            chart.data.labels.push(label);
            chart.data.datasets.forEach((dataset) => {
                dataset.data.push(data);
            });
            if (chart.data.labels.length > max_items) {
                chart.data.labels.shift();
                chart.data.datasets[0].data.shift();
            }
        }
        chart.update();
    }

    // add item to cache
    function setItemChart(cacheObj, key, labels, datas, max=null) {
        cacheObj[key]={
            'datas' : datas,
            'labels' : labels,
            'max' : max
        };
    }

    // store chart datas to cache
    function storeItemChart(cacheObj, key, chart) {
        cacheObj[key]={
            'datas' : chart.data.datasets[0].data,
            'labels' : chart.data.labels,
            'max' : chart.options.scales.yAxes[0].ticks.max
        };
    }

    function storeCurrentContext(type_date=0) {
        storeItemChart(cacheChart[type_date], 'startedChart', startedChart);
        storeItemChart(cacheChart[type_date], 'memoryChart', memoryChart);
        storeItemChart(cacheChart[type_date], 'storageChart', storageChart);
        storeItemChart(cacheChart[type_date], 'cpu_usageChart', cpu_usageChart);
    }

    function changeContext(type_date=0) {
        // store before change context
        storeCurrentContext(type_stats);
        type_stats=type_date;
        if (type_date in cacheChart && ! datasOutdated[type_date])
            drawChartsFromCache(type_date); // refresh (from cache)
        else
            getInitialChartDatas(type_date); // not in cache
    }

    $('#hour').on('click',function(){
        changeContext(0);
        $('#day').removeClass('active');
        $(this).addClass('active');
    });
    
    $('#day').on('click',function(){
        changeContext(1);
        $('#hour').removeClass('active');
        $(this).addClass('active');
    });

</script>
